MoreParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
MoreParser Class Referencefinal

the main class to read a More file More...

`#include <MoreParser.hxx>`

Inheritance diagram for MoreParser:

## Public Member Functions
| MoreParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor More...
| ~MoreParser () final
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
void | newPage (int number)
| adds a new page More...
bool | getColor (int id, MWAWColor &col) const
| return the color which corresponds to an id (if possible) More...
bool | createZones ()
| finds the different objects zones More...
bool | readZonesList ()
| read the list of zones ( v2-3) : first 0x80 bytes More...
bool | readPrintInfo (MWAWEntry const &entry)
| read a PrintInfo zone ( first block ) More...
bool | readDocumentInfo (MWAWEntry const &entry)
| read a docinfo zone ( second block ) More...
bool | readSlideList (MWAWEntry const &entry)
| read the list of slide definitions More...
bool | readSlide (MWAWEntry const &entry)
| read a slide definitions More...
bool | readGraphic (MWAWEntry const &entry)
| read a graphic ( in a slide ) More...
bool | readUnknown9 (MWAWEntry const &entry)
| read a unknown zone ( block 9 ) More...
bool | readColors (long endPos)
| read a color zone ( beginning of block 9 ) More...
bool | readPattern (long endPos, MoreStruct::Pattern &pattern)
| read a pattern ( some sub zone of block 9) More...
bool | readBackside (long endPos, std::string &extra)
| read a backside ( some sub zone of block 9) More...
bool | readFreePos (MWAWEntry const &entry)
| read the list of free file position More...
bool | readUnkn9Sub (long endPos)
| read the last subzone find in a block 9 ( unknown meaning) More...
bool | checkAndStore (MWAWEntry const &entry)
| check if the entry is valid, if so store it in the list of entry More...
bool | checkAndFindSize (MWAWEntry &entry)
| check if the entry is valid defined by the begin pos points to a zone: dataSz data More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
std::shared_ptr< MoreParserInternal::State > | m_state
| the state More...
std::shared_ptr< MoreText > | m_textParser
| the text parser More...

## Friends
class | MoreParserInternal::SubDocument
class | MoreText

## Detailed Description

the main class to read a More file

## Constructor & Destructor Documentation

## ◆ MoreParser()

MoreParser::MoreParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~MoreParser()

MoreParser::~MoreParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkAndFindSize()

bool MoreParser::checkAndFindSize | ( | MWAWEntry & | entry | ) |
| protected

check if the entry is valid defined by the begin pos points to a zone: dataSz data

Referenced by MoreText::readComment(), MoreText::readOutlineList(), readSlideList(), MoreText::readSpeakerNote(), and MoreText::readTopic().

## ◆ checkAndStore()

bool MoreParser::checkAndStore | ( | MWAWEntry const & | entry | ) |
| protected

check if the entry is valid, if so store it in the list of entry

Referenced by readZonesList().

## ◆ checkHeader()

bool MoreParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void MoreParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool MoreParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ getColor()

bool MoreParser::getColor | ( | int | id,
|  | MWAWColor & | col
| ) |  | const
| protected

return the color which corresponds to an id (if possible)

## ◆ getPageLeftTop()

MWAWVec2f MoreParser::getPageLeftTop | ( |  | ) | const
| protected

returns the page left top point ( in inches)

## ◆ init()

void MoreParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by MoreParser().

## ◆ newPage()

void MoreParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by MoreText::sendTopic().

## ◆ parse()

void MoreParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readBackside()

bool MoreParser::readBackside | ( | long | endPos,
|  | std::string & | extra
| ) |  |
| protected

read a backside ( some sub zone of block 9)

Referenced by MoreText::parseUnknown(), and readUnknown9().

## ◆ readColors()

bool MoreParser::readColors | ( | long | endPos | ) |
| protected

read a color zone ( beginning of block 9 )

Referenced by readUnknown9().

## ◆ readDocumentInfo()

bool MoreParser::readDocumentInfo | ( | MWAWEntry const & | entry | ) |
| protected

read a docinfo zone ( second block )

Referenced by createZones().

## ◆ readFreePos()

bool MoreParser::readFreePos | ( | MWAWEntry const & | entry | ) |
| protected

read the list of free file position

Referenced by createZones().

## ◆ readGraphic()

bool MoreParser::readGraphic | ( | MWAWEntry const & | entry | ) |
| protected

read a graphic ( in a slide )

Referenced by readSlide().

## ◆ readPattern()

bool MoreParser::readPattern | ( | long | endPos,
|  | MoreStruct::Pattern & | pattern
| ) |  |
| protected

read a pattern ( some sub zone of block 9)

Referenced by MoreText::parseUnknown(), and readUnknown9().

## ◆ readPrintInfo()

bool MoreParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |
| protected

read a PrintInfo zone ( first block )

Referenced by createZones().

## ◆ readSlide()

bool MoreParser::readSlide | ( | MWAWEntry const & | entry | ) |
| protected

read a slide definitions

Referenced by readSlideList().

## ◆ readSlideList()

bool MoreParser::readSlideList | ( | MWAWEntry const & | entry | ) |
| protected

read the list of slide definitions

Referenced by createZones().

## ◆ readUnkn9Sub()

bool MoreParser::readUnkn9Sub | ( | long | endPos | ) |
| protected

read the last subzone find in a block 9 ( unknown meaning)

Referenced by readUnknown9().

## ◆ readUnknown9()

bool MoreParser::readUnknown9 | ( | MWAWEntry const & | entry | ) |
| protected

read a unknown zone ( block 9 )

Referenced by createZones().

## ◆ readZonesList()

bool MoreParser::readZonesList | ( |  | ) |
| protected

read the list of zones ( v2-3) : first 0x80 bytes

Referenced by createZones().

## ◆ rsrcAscii()

libmwaw::DebugFile & MoreParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

## ◆ rsrcInput()

MWAWInputStreamPtr MoreParser::rsrcInput | ( |  | ) |
| protected

return the input input

## Friends And Related Function Documentation

## ◆ MoreParserInternal::SubDocument

friend class MoreParserInternal::SubDocument
| friend

## ◆ MoreText

friend class MoreText
| friend

Referenced by init().

## Member Data Documentation

## ◆ m_state

std::shared_ptr<MoreParserInternal::State> MoreParser::m_state
| protected

the state

Referenced by checkAndStore(), checkHeader(), createDocument(), createZones(), getColor(), init(), newPage(), readDocumentInfo(), and readZonesList().

## ◆ m_textParser

std::shared_ptr<MoreText> MoreParser::m_textParser
| protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), and readSlide().

The documentation for this class was generated from the following files:

- MoreParser.hxx
- MoreParser.cxx